//PINBELEGUNG
//Stepper
#define stepdir1 2 //Dir  rechtes Rad
#define stepstep1 3 //Step rechtes Rad
#define stepstep2 4 //Step linkes Rad
#define stepdir2 5 //Dir  linkes Rad

//Farbsensor
#define S0 A7
#define S1 7
#define S2 8
#define S3 12
#define sensorOut 13    

//Lenkmotor
#define MOTOR_1 0
#define BRAKE 0
#define CW  1
#define CCW 2
#define MOTOR_B1_PIN 10
#define MOTOR_A1_PIN 9
#define PWM_MOTOR_1 11
#define CURRENT_SEN_1 A2
#define CS_THRESHOLD 15
#define EN_PIN_1 A3

//Infrarotsensoren
#define read1 A0
#define read2 A1

//LED Strip
#define REDPIN A5
#define GREENPIN A4
#define BLUEPIN A6

short usSpeed = 40;  //default motor speed
unsigned short usMotor_Status = BRAKE;

void setup() {
  Serial.begin(9600);
  pinMode(stepdir1, OUTPUT); 
  pinMode(stepstep1, OUTPUT); 
  pinMode(stepstep2, OUTPUT); 
  pinMode(stepdir2, OUTPUT); 
  pinMode(S0, OUTPUT);
  pinMode(S1, OUTPUT);
  pinMode(S2, OUTPUT);
  pinMode(S3, OUTPUT);
  pinMode(sensorOut, INPUT);
  pinMode(MOTOR_A1_PIN, OUTPUT);
  pinMode(MOTOR_B1_PIN, OUTPUT);
  pinMode(PWM_MOTOR_1, OUTPUT);
  pinMode(CURRENT_SEN_1, OUTPUT);
  pinMode(EN_PIN_1, OUTPUT);
  pinMode(REDPIN, OUTPUT);
  pinMode(GREENPIN, OUTPUT);
  pinMode(BLUEPIN, OUTPUT);

  // Steppereinstellung
  digitalWrite(2, HIGH);
  digitalWrite(5, LOW);

  // Farbsensoreinstellung
  digitalWrite(S0, HIGH);
  digitalWrite(S1, LOW);
  digitalWrite(S2, LOW);
  digitalWrite(S3, LOW);
}

void loop() {
  int messung1 = analogRead(read1); //Messung rechter Sensor
  int messung2 = analogRead(read2); //Messung linker Sensor
  int delay1 = 500; //Delay bestimmt die Schnelligkeit der Stepper
  int delay2 = 800; //Delay bestimmt die Schnelligkeit der Stepper in der Lenkung

  while (messung1 <= 25 && messung2 <= 25) { //fährt geradeaus
    Links();
    digitalWrite(3, HIGH);
    delayMicroseconds(delay1);
    digitalWrite(3, LOW);
    delayMicroseconds(delay1);
    digitalWrite(4, HIGH);
    delayMicroseconds(delay1);
    digitalWrite(4, LOW);
    delayMicroseconds(delay1);
    messung1 = analogRead(A0); 
    messung2 = analogRead(A1);
    analogWrite(GREENPIN, 160);
  }

  while (messung1 <= 25 && messung2 >= 550) { //Lenkung nach rechts
    Links();
    digitalWrite(4, HIGH);
    delayMicroseconds(delay2);
    digitalWrite(4, LOW);
    delayMicroseconds(delay2);
    messung1 = analogRead(A0); 
    messung2 = analogRead(A1);
    analogWrite(BLUEPIN, 255);
  }

  while (messung1 >= 550 && messung2 <= 25) { // Lenkung nach links
    Rechts();
    digitalWrite(3, HIGH);
    delayMicroseconds(delay2);
    digitalWrite(3, LOW);
    delayMicroseconds(delay2);
    messung1 = analogRead(A0); 
    messung2 = analogRead(A1);
    analogWrite(REDPIN, 255);

  }
}

void Stop() {
  usMotor_Status = BRAKE;
  motorGo(MOTOR_1, usMotor_Status, 0);
}
void Links() { //Lenkungsmotor im Uhrzeigersinn
  usMotor_Status = CW;
  motorGo(MOTOR_1, usMotor_Status, usSpeed);
}
void Rechts() { //Lenkungsmotor gegen den Uhrzeigersinn
  usMotor_Status = CCW;
  motorGo(MOTOR_1, usMotor_Status, usSpeed);
}

void motorGo(uint8_t motor, uint8_t direct, uint8_t pwm)   {  //Funktion zur Steuerung des Lenkungsmotors
  if (motor == MOTOR_1)
  {
    if (direct == CW)    {
      digitalWrite(MOTOR_A1_PIN, LOW);
      digitalWrite(MOTOR_B1_PIN, HIGH);
    }
    else if (direct == CCW)    {
      digitalWrite(MOTOR_A1_PIN, HIGH);
      digitalWrite(MOTOR_B1_PIN, LOW);
    }
    else    {
      digitalWrite(MOTOR_A1_PIN, LOW);
      digitalWrite(MOTOR_B1_PIN, LOW);
    }
    analogWrite(PWM_MOTOR_1, pwm);
  }
}

void farberkennen() { //Funktion für die Farberkennung
  
  //Kalibrierung des roten Farbwertes
  digitalWrite(S2,LOW);
  digitalWrite(S3,LOW);
  int redFrequency = pulseIn(sensorOut, LOW); 
  int redColor = map(redFrequency, 70, 120, 255, 0);

  //Kalibrierung des grünen Farbwertes
  digitalWrite(S2,HIGH);
  digitalWrite(S3,HIGH);
  int greenFrequency = pulseIn(sensorOut, LOW);
  int greenColor = map(greenFrequency, 120, 199, 255, 0);

  //Kalibrierung des blauen Farbwertes
  digitalWrite(S2,LOW);
  digitalWrite(S3,HIGH);
  int blueFrequency = pulseIn(sensorOut, LOW);
  int blueColor = map(blueFrequency, 80, 120, 255, 0);

  if(redColor > greenColor && redColor > blueColor){ //Farberkennung rot
    Serial.println("Rot");
  } 
  if(greenColor > redColor && greenColor > blueColor){ //Farberkennung Grün
    Serial.println("Grün");
    analogWrite(GREENPIN, 255);
  }
  if(blueColor > redColor && blueColor > greenColor){ //Farberkennung Blau
    Serial.println("Blau");
    analogWrite(BLUEPIN, 255);
    
    
    
  }

}
